const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const campaign_recipients = sequelize.define(
    'campaign_recipients',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

delivery_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"sent",


"delivered",


"failed"

        ],

      },

delivered_at: {
        type: DataTypes.DATE,
      
      

      },

provider_reference: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  campaign_recipients.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.campaign_recipients.belongsTo(db.marketing_campaigns, {
      as: 'campaign',
      foreignKey: {
        name: 'campaignId',
      },
      constraints: false,
    });

    db.campaign_recipients.belongsTo(db.customers, {
      as: 'customer',
      foreignKey: {
        name: 'customerId',
      },
      constraints: false,
    });

    db.campaign_recipients.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.campaign_recipients.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.campaign_recipients.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return campaign_recipients;
};


